`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:13:55 10/09/2017 
// Design Name: 
// Module Name:    delta2 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Input :
// 	:32 bits (signed Q24)
// Output:
// 	delta2_i : 32 bits (signed Q24)
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

module delta2(clk, res, dadz2_i, w3_i1, w3_i2, delta3_1, delta3_2, delta2_i);
	input				        clk;
	input						  res;
	input 	signed [31:0] dadz2_i, w3_i1, w3_i2;
	input 	signed [31:0] delta3_1, delta3_2;
	output 	signed [31:0] delta2_i;
//	reg		signed [31:0] delta2_i;
	reg		signed [95:0] tmp_delta2_i;
	
	always@(posedge clk or posedge res)
	 begin
		if (res == 1'b1)
			tmp_delta2_i = 0;
		else 
				tmp_delta2_i = (w3_i1 * delta3_1 + w3_i2 * delta3_2) * dadz2_i;
	 end

	assign delta2_i = tmp_delta2_i[79:48];
	
endmodule
