`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:39:10 10/10/2017 
// Design Name: 
// Module Name:    dw 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module dw(clk, res, unit_error, input_signal, renew_parameter);
	input clk;
	input res;
	input signed [31:0] unit_error;
	input signed [31:0] input_signal;
	output signed [31:0] renew_parameter;
//	reg signed [31:0]	  renew_parameter;
	reg signed [63:0]	q;
	
	always@(posedge clk or posedge res)
	 begin
		if (res == 1'b1)
			q = 0;
		else
			q = unit_error * input_signal;
	end
	
	assign 	renew_parameter = q[55:24];

endmodule

